﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DWZB_Agv_Agreement.Agv_Agreement
{
    /// <summary>
    /// 任务下发指令实体类
    /// </summary>
    public class AgvTaskSendMd : DataHeadMd
    {
        private const int btyArrLen = 33;
        /// <summary>
        /// 指令编号
        /// </summary>
        public int CmdNo { get; set; }
        /// <summary>
        /// 指令代码
        /// </summary>
        public byte CmdCode { get; set; }
        /// <summary>
        /// 任务类型
        /// </summary>
        public byte TaskType { get; set; }
        /// <summary>
        /// 抱夹动作
        /// </summary>
        public byte ClipAction { get; set; }
        /// <summary>
        /// 移动方式
        /// </summary>
        public byte MoveMode { get; set; }
        /// <summary>
        /// 目标点X坐标
        /// </summary>
        public float Target_X { get; set; }
        /// <summary>
        /// 目标点Y坐标
        /// </summary>
        public float Target_Y { get; set; }
        /// <summary>
        /// 目标点角度
        /// </summary>
        public float Target_Angle { get; set; }
        /// <summary>
        /// 移动速度
        /// </summary>
        public float Speed { get; set; }
        /// <summary>
        /// 目标点1 RFID编号
        /// </summary>
        public int Target_rfidNo { get; set; }
        /// <summary>
        /// 序列化为byte数组。
        /// </summary>
        public byte[] SerializeBytArr()
        {
            List<byte> retBtArr = new(btyArrLen);
            retBtArr.Add(FunctionCode);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(AgvNo)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(CmdNo)));
            retBtArr.Add(CmdCode);
            retBtArr.Add(TaskType);
            retBtArr.Add(ClipAction);
            retBtArr.Add(MoveMode);
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Target_X)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Target_Y)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Target_Angle)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Speed)));
            retBtArr.AddRange(DataHandleHelper.ReverseBtyArr(BitConverter.GetBytes(Target_rfidNo)));
            return retBtArr.ToArray();
        }
    }
}
