﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace DWZB_Agv_Agreement
{
    public static class JsonHelper
    {
        private static JsonSerializerSettings jsonSerializerSetting = new JsonSerializerSettings()
        {
            ContractResolver = new Newtonsoft.Json.Serialization.DefaultContractResolver()
            {
                NamingStrategy = new Newtonsoft.Json.Serialization.SnakeCaseNamingStrategy()
            },
            NullValueHandling = NullValueHandling.Ignore
        };
        public static string ToJsonExt(object data)
        {
            return JsonConvert.SerializeObject(data, jsonSerializerSetting);
        }
        /// <summary>
        /// 对象序列化为json字符串
        /// </summary>
        /// <param name="data">对象</param>
        /// <returns></returns>
        public static string ToJson(object data)
        {
            return JsonConvert.SerializeObject(data);
        }
        /// <summary>
        /// json字符串反序列化为对象
        /// </summary>
        /// <typeparam name="T">对象</typeparam>
        /// <param name="data">json数据</param>
        /// <returns></returns>
        public static T ToObject<T>(string data)
        {
            return JsonConvert.DeserializeObject<T>(data);
        }

    }
}
